﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Diagrams.Core;

namespace DiagramResizing
{
    public class CustomResizingService : ResizingService
    {
        private IEnumerable<IDiagramItem> resizingItems;

        public CustomResizingService(RadDiagram owner)
            : base(owner as IGraphInternal)
        {
        }

        public override void InitializeResize(IEnumerable<IDiagramItem> newSelectedItems, double adornerAngle, Rect adornerBounds, ResizeDirection resizingDirection, Point startPoint)
        {
            base.InitializeResize(newSelectedItems, adornerAngle, adornerBounds, resizingDirection, startPoint);
            this.resizingItems = newSelectedItems;
        }

        protected override Point CalculateNewDelta(Point newPoint)
        {
            var newDelta = base.CalculateNewDelta(newPoint);
            var textShapes = this.resizingItems.Any(i => i is RadDiagramTextShape);
            return new Point(newDelta.X, textShapes ? 0 : newDelta.Y);
        }
    }
}
